import numpy as np
from scipy.sparse import vstack


# We write x_it to be the number of times word wt occurs in document x_i. When a document is to be generated by a
# particular mixture component a document length is first chosen independently of the component.
# This assumes that document length is independent of class.
def doc_len_prob(X):
    docs_lens = np.array(
        X.sum(axis=1), dtype=str
    ).ravel()  # count number of words in each doc, i.e. lengths of documents
    n = len(docs_lens)
    docs_lens_prob = np.empty(n, dtype=float)  # empty array for writing prob values

    # for every document count documents with same lenght and devide this number by number of all documents
    for i in range(n):
        docs_lens_prob[i] = np.count_nonzero(docs_lens == docs_lens[i]) / n
    return np.matrix(docs_lens_prob).T


def log_prob(X_u, X_l, y_labels, feature_log_prob, class_log_prior):
    docs_len_ = np.log(doc_len_prob(vstack((X_u, X_l))))
    feature_prob_mat_ = np.matrix(feature_log_prob)

    # unlabled
    Xu_ = X_u.toarray()
    docs_prob_u_ = np.empty((class_log_prior.shape[0], Xu_.shape[0]))
    for i in range(Xu_.shape[0]):
        for j in range(class_log_prior.shape[0]):
            docs_prob_u_[j][i] = (
                class_log_prior[j]
                + docs_len_[X_l.shape[0] :][i].item()
                + feature_prob_mat_[j] * np.matrix(Xu_[i]).T
            ).item()
    # labeled
    Xl_ = np.matrix(X_l.toarray())
    y_ = np.array(y_labels, dtype=int)
    docs_prob_l_ = np.empty(Xl_.shape[0])
    for i in range(len(y_)):
        cl_ = y_[i]
        docs_prob_l_[i] = (
            class_log_prior[cl_]
            + docs_len_[: X_l.shape[0]][i].item()
            + (feature_prob_mat_[cl_] * np.matrix(Xl_[i]).T).item()
        )
    # Python sum() vs numpy sum() # https://stackoverflow.com/questions/10922231/pythons-sum-vs-numpys-numpy-sum
    return np.sum(docs_prob_l_) + np.sum(docs_prob_u_)
